Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.cpp	(revision 47121)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.cpp	(revision 47130)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -32,16 +32,10 @@
 
 #ifndef Q_WS_MAC
-    m_pEnablePresentationModeCheckbox->hide();
-    m_pSpacerWidget2->hide();
+    m_pPresentationModeLabel->hide();
+    m_pPresentationModeCheckbox->hide();
 #endif /* !Q_WS_MAC */
-//#ifndef Q_WS_WIN /* Checkbox hidden for now! */
-    m_pDisableHostScreenSaverCheckbox->hide();
-    m_pSpacerWidget3->hide();
-//#endif /* !Q_WS_WIN */
-
-    /* If all checkboxes hidden, hide separator too: */
-    if (m_pEnablePresentationModeCheckbox->isHidden() &&
-        m_pDisableHostScreenSaverCheckbox->isHidden())
-        m_pLineSeparator2->hide();
+    /* Hide checkbox for now: */
+    m_pHostScreenSaverLabel->hide();
+    m_pHostScreenSaverCheckbox->hide();
 
     /* Setup widgets: */
@@ -67,5 +61,5 @@
     m_cache.m_fPresentationModeEnabled = m_settings.presentationModeEnabled();
 #endif /* Q_WS_MAC */
-    m_cache.m_fHostScreenSaverDisables = m_settings.hostScreenSaverDisabled();
+    m_cache.m_fHostScreenSaverDisabled = m_settings.hostScreenSaverDisabled();
 
     /* Upload properties & settings to data: */
@@ -81,7 +75,7 @@
     m_pVRDPLibNameSelector->setPath(m_cache.m_strVRDEAuthLibrary);
 #ifdef Q_WS_MAC
-    m_pEnablePresentationModeCheckbox->setChecked(m_cache.m_fPresentationModeEnabled);
+    m_pPresentationModeCheckbox->setChecked(m_cache.m_fPresentationModeEnabled);
 #endif /* Q_WS_MAC */
-    m_pDisableHostScreenSaverCheckbox->setChecked(m_cache.m_fHostScreenSaverDisables);
+    m_pHostScreenSaverCheckbox->setChecked(m_cache.m_fHostScreenSaverDisabled);
 }
 
@@ -94,7 +88,7 @@
     m_cache.m_strVRDEAuthLibrary = m_pVRDPLibNameSelector->path();
 #ifdef Q_WS_MAC
-    m_cache.m_fPresentationModeEnabled = m_pEnablePresentationModeCheckbox->isChecked();
+    m_cache.m_fPresentationModeEnabled = m_pPresentationModeCheckbox->isChecked();
 #endif /* Q_WS_MAC */
-    m_cache.m_fHostScreenSaverDisables = m_pDisableHostScreenSaverCheckbox->isChecked();
+    m_cache.m_fHostScreenSaverDisabled = m_pHostScreenSaverCheckbox->isChecked();
 }
 
@@ -114,5 +108,5 @@
     m_settings.setPresentationModeEnabled(m_cache.m_fPresentationModeEnabled);
 #endif /* Q_WS_MAC */
-    m_settings.setHostScreenSaverDisabled(m_cache.m_fHostScreenSaverDisables);
+    m_settings.setHostScreenSaverDisabled(m_cache.m_fHostScreenSaverDisabled);
 
     /* Upload properties & settings to data: */
@@ -125,6 +119,6 @@
     setTabOrder(pWidget, m_pMachineFolderSelector);
     setTabOrder(m_pMachineFolderSelector, m_pVRDPLibNameSelector);
-    setTabOrder(m_pVRDPLibNameSelector, m_pEnablePresentationModeCheckbox);
-    setTabOrder(m_pEnablePresentationModeCheckbox, m_pDisableHostScreenSaverCheckbox);
+    setTabOrder(m_pVRDPLibNameSelector, m_pPresentationModeCheckbox);
+    setTabOrder(m_pPresentationModeCheckbox, m_pHostScreenSaverCheckbox);
 }
 
@@ -134,12 +128,4 @@
     /* Translate uic generated strings: */
     Ui::UIGlobalSettingsGeneral::retranslateUi(this);
-
-    m_pMachineFolderSelector->setWhatsThis(tr("Displays the path to the default virtual "
-                                              "machine folder. This folder is used, if not "
-                                              "explicitly specified otherwise, when creating "
-                                              "new virtual machines."));
-    m_pVRDPLibNameSelector->setWhatsThis(tr("Displays the path to the library that "
-                                            "provides authentication for Remote Display "
-                                            "(VRDP) clients."));
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.h	(revision 47121)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.h	(revision 47130)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2012 Oracle Corporation
+ * Copyright (C) 2006-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -32,5 +32,5 @@
     bool m_fPresentationModeEnabled;
 #endif /* Q_WS_MAC */
-    bool m_fHostScreenSaverDisables;
+    bool m_fHostScreenSaverDisabled;
 };
 
@@ -74,3 +74,2 @@
 
 #endif // __UIGlobalSettingsGeneral_h__
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.ui	(revision 47121)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.ui	(revision 47130)
@@ -27,5 +27,5 @@
     <number>0</number>
    </property>
-   <item row="0" column="0" colspan="2">
+   <item row="0" column="0">
     <widget class="QLabel" name="m_pMachineFolderLabel">
      <property name="text">
@@ -40,5 +40,5 @@
     </widget>
    </item>
-   <item row="0" column="2">
+   <item row="0" column="1">
     <widget class="VBoxFilePathSelectorWidget" name="m_pMachineFolderSelector">
      <property name="sizePolicy">
@@ -48,15 +48,11 @@
       </sizepolicy>
      </property>
-    </widget>
-   </item>
-   <item row="1" column="0" colspan="3">
-    <widget class="Line" name="m_pLineSeparator1">
-     <property name="orientation">
-      <enum>Qt::Horizontal</enum>
+     <property name="whatsThis">
+      <string>Displays the path to the default virtual machine folder. This folder is used, if not explicitly specified otherwise, when creating new virtual machines.</string>
      </property>
     </widget>
    </item>
-   <item row="2" column="0" colspan="2">
-    <widget class="QLabel" name="m_pVRDPLibLabel">
+   <item row="1" column="0">
+    <widget class="QLabel" name="m_pVRDPLibNameLabel">
      <property name="text">
       <string>V&amp;RDP Authentication Library:</string>
@@ -70,5 +66,5 @@
     </widget>
    </item>
-   <item row="2" column="2">
+   <item row="1" column="1">
     <widget class="VBoxFilePathSelectorWidget" name="m_pVRDPLibNameSelector">
      <property name="sizePolicy">
@@ -78,57 +74,56 @@
       </sizepolicy>
      </property>
-    </widget>
-   </item>
-   <item row="3" column="0" colspan="3">
-    <widget class="Line" name="m_pLineSeparator2">
-     <property name="orientation">
-      <enum>Qt::Horizontal</enum>
+     <property name="whatsThis">
+      <string>Displays the path to the library that provides authentication for Remote Display (VRDP) clients.</string>
      </property>
     </widget>
    </item>
-   <item row="4" column="0">
-    <widget class="QWidget" name="m_pSpacerWidget2">
-     <property name="sizePolicy">
-      <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
-       <horstretch>0</horstretch>
-       <verstretch>0</verstretch>
-      </sizepolicy>
+   <item row="2" column="0">
+    <widget class="QLabel" name="m_pPresentationModeLabel">
+     <property name="text">
+      <string>&amp;Dock and Menubar:</string>
      </property>
-     <property name="minimumWidth">
-      <number>34</number>
+     <property name="alignment">
+      <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+     </property>
+     <property name="buddy">
+      <cstring>m_pPresentationModeCheckbox</cstring>
      </property>
     </widget>
    </item>
-   <item row="4" column="1" colspan="2">
-    <widget class="QCheckBox" name="m_pEnablePresentationModeCheckbox">
+   <item row="2" column="1">
+    <widget class="QCheckBox" name="m_pPresentationModeCheckbox">
      <property name="text">
-      <string>&amp;Auto show Dock and Menubar in fullscreen</string>
+      <string>Auto Show in Fullscreen</string>
+     </property>
+     <property name="whatsThis">
+      <string>When checked, Dock and Menubar will be shown in virtual machine fullscreen.</string>
      </property>
     </widget>
    </item>
-   <item row="5" column="0">
-    <widget class="QWidget" name="m_pSpacerWidget3">
-     <property name="sizePolicy">
-      <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
-       <horstretch>0</horstretch>
-       <verstretch>0</verstretch>
-      </sizepolicy>
+   <item row="3" column="0">
+    <widget class="QLabel" name="m_pHostScreenSaverLabel">
+     <property name="text">
+      <string>&amp;Host Screen Saver:</string>
      </property>
-     <property name="minimumWidth">
-      <number>34</number>
+     <property name="alignment">
+      <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+     </property>
+     <property name="buddy">
+      <cstring>m_pHostScreenSaverCheckbox</cstring>
      </property>
     </widget>
    </item>
-   <item row="5" column="1" colspan="2">
-    <widget class="QCheckBox" name="m_pDisableHostScreenSaverCheckbox">
+   <item row="3" column="1">
+    <widget class="QCheckBox" name="m_pHostScreenSaverCheckbox">
      <property name="whatsThis">
       <string>When checked, the host screen saver will be disabled whenever a virtual machine is running.</string>
      </property>
      <property name="text">
-      <string>Disable Host &amp;ScreenSaver</string>
+      <string>Disable at Virtual Machine Runtime</string>
      </property>
     </widget>
    </item>
-   <item row="6" column="0" colspan="3">
+   <item row="4" column="0" colspan="2">
     <spacer>
      <property name="orientation">