Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.cpp	(revision 47133)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.cpp	(revision 47134)
@@ -18,12 +18,11 @@
  */
 
-/* Global includes */
+/* Qt includes: */
 #include <QDir>
 
-/* Local includes */
+/* GUI includes: */
 #include "UIGlobalSettingsGeneral.h"
 #include "VBoxGlobal.h"
 
-/* General page constructor: */
 UIGlobalSettingsGeneral::UIGlobalSettingsGeneral()
 {
@@ -32,15 +31,15 @@
 
 #ifndef Q_WS_MAC
-    m_pPresentationModeLabel->hide();
-    m_pPresentationModeCheckbox->hide();
+    m_pLabelPresentationMode->hide();
+    m_pCheckBoxPresentationMode->hide();
 #endif /* !Q_WS_MAC */
     /* Hide checkbox for now: */
-    m_pHostScreenSaverLabel->hide();
-    m_pHostScreenSaverCheckbox->hide();
+    m_pLabelHostScreenSaver->hide();
+    m_pCheckBoxHostScreenSaver->hide();
 
     /* Setup widgets: */
-    m_pMachineFolderSelector->setHomeDir(vboxGlobal().virtualBox().GetHomeFolder());
-    m_pVRDPLibNameSelector->setHomeDir(vboxGlobal().virtualBox().GetHomeFolder());
-    m_pVRDPLibNameSelector->setMode(VBoxFilePathSelectorWidget::Mode_File_Open);
+    m_pSelectorMachineFolder->setHomeDir(vboxGlobal().virtualBox().GetHomeFolder());
+    m_pSelectorVRDPLibName->setHomeDir(vboxGlobal().virtualBox().GetHomeFolder());
+    m_pSelectorVRDPLibName->setMode(VBoxFilePathSelectorWidget::Mode_File_Open);
 
     /* Apply language settings: */
@@ -72,10 +71,10 @@
 {
     /* Fetch from cache: */
-    m_pMachineFolderSelector->setPath(m_cache.m_strDefaultMachineFolder);
-    m_pVRDPLibNameSelector->setPath(m_cache.m_strVRDEAuthLibrary);
+    m_pSelectorMachineFolder->setPath(m_cache.m_strDefaultMachineFolder);
+    m_pSelectorVRDPLibName->setPath(m_cache.m_strVRDEAuthLibrary);
 #ifdef Q_WS_MAC
-    m_pPresentationModeCheckbox->setChecked(m_cache.m_fPresentationModeEnabled);
+    m_pCheckBoxPresentationMode->setChecked(m_cache.m_fPresentationModeEnabled);
 #endif /* Q_WS_MAC */
-    m_pHostScreenSaverCheckbox->setChecked(m_cache.m_fHostScreenSaverDisabled);
+    m_pCheckBoxHostScreenSaver->setChecked(m_cache.m_fHostScreenSaverDisabled);
 }
 
@@ -85,10 +84,10 @@
 {
     /* Upload to cache: */
-    m_cache.m_strDefaultMachineFolder = m_pMachineFolderSelector->path();
-    m_cache.m_strVRDEAuthLibrary = m_pVRDPLibNameSelector->path();
+    m_cache.m_strDefaultMachineFolder = m_pSelectorMachineFolder->path();
+    m_cache.m_strVRDEAuthLibrary = m_pSelectorVRDPLibName->path();
 #ifdef Q_WS_MAC
-    m_cache.m_fPresentationModeEnabled = m_pPresentationModeCheckbox->isChecked();
+    m_cache.m_fPresentationModeEnabled = m_pCheckBoxPresentationMode->isChecked();
 #endif /* Q_WS_MAC */
-    m_cache.m_fHostScreenSaverDisabled = m_pHostScreenSaverCheckbox->isChecked();
+    m_cache.m_fHostScreenSaverDisabled = m_pCheckBoxHostScreenSaver->isChecked();
 }
 
@@ -101,7 +100,7 @@
 
     /* Save from cache: */
-    if (m_properties.isOk() && m_pMachineFolderSelector->isModified())
+    if (m_properties.isOk() && m_pSelectorMachineFolder->isModified())
         m_properties.SetDefaultMachineFolder(m_cache.m_strDefaultMachineFolder);
-    if (m_properties.isOk() && m_pVRDPLibNameSelector->isModified())
+    if (m_properties.isOk() && m_pSelectorVRDPLibName->isModified())
         m_properties.SetVRDEAuthLibrary(m_cache.m_strVRDEAuthLibrary);
 #ifdef Q_WS_MAC
@@ -114,14 +113,13 @@
 }
 
-/* Navigation stuff: */
 void UIGlobalSettingsGeneral::setOrderAfter(QWidget *pWidget)
 {
-    setTabOrder(pWidget, m_pMachineFolderSelector);
-    setTabOrder(m_pMachineFolderSelector, m_pVRDPLibNameSelector);
-    setTabOrder(m_pVRDPLibNameSelector, m_pPresentationModeCheckbox);
-    setTabOrder(m_pPresentationModeCheckbox, m_pHostScreenSaverCheckbox);
+    /* Configure navigation: */
+    setTabOrder(pWidget, m_pSelectorMachineFolder);
+    setTabOrder(m_pSelectorMachineFolder, m_pSelectorVRDPLibName);
+    setTabOrder(m_pSelectorVRDPLibName, m_pCheckBoxPresentationMode);
+    setTabOrder(m_pCheckBoxPresentationMode, m_pCheckBoxHostScreenSaver);
 }
 
-/* Translation stuff: */
 void UIGlobalSettingsGeneral::retranslateUi()
 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.ui
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.ui	(revision 47133)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsGeneral.ui	(revision 47134)
@@ -15,12 +15,4 @@
  <class>UIGlobalSettingsGeneral</class>
  <widget class="QWidget" name="UIGlobalSettingsGeneral">
-  <property name="geometry">
-   <rect>
-    <x>0</x>
-    <y>0</y>
-    <width>400</width>
-    <height>200</height>
-   </rect>
-  </property>
   <layout class="QGridLayout">
    <property name="margin">
@@ -28,5 +20,5 @@
    </property>
    <item row="0" column="0">
-    <widget class="QLabel" name="m_pMachineFolderLabel">
+    <widget class="QLabel" name="m_pLabelMachineFolder">
      <property name="text">
       <string>Default &amp;Machine Folder:</string>
@@ -36,10 +28,10 @@
      </property>
      <property name="buddy">
-      <cstring>m_pMachineFolderSelector</cstring>
+      <cstring>m_pSelectorMachineFolder</cstring>
      </property>
     </widget>
    </item>
    <item row="0" column="1">
-    <widget class="VBoxFilePathSelectorWidget" name="m_pMachineFolderSelector">
+    <widget class="VBoxFilePathSelectorWidget" name="m_pSelectorMachineFolder">
      <property name="sizePolicy">
       <sizepolicy hsizetype="MinimumExpanding" vsizetype="Fixed">
@@ -54,5 +46,5 @@
    </item>
    <item row="1" column="0">
-    <widget class="QLabel" name="m_pVRDPLibNameLabel">
+    <widget class="QLabel" name="m_pLabelVRDPLibName">
      <property name="text">
       <string>V&amp;RDP Authentication Library:</string>
@@ -62,10 +54,10 @@
      </property>
      <property name="buddy">
-      <cstring>m_pVRDPLibNameSelector</cstring>
+      <cstring>m_pSelectorVRDPLibName</cstring>
      </property>
     </widget>
    </item>
    <item row="1" column="1">
-    <widget class="VBoxFilePathSelectorWidget" name="m_pVRDPLibNameSelector">
+    <widget class="VBoxFilePathSelectorWidget" name="m_pSelectorVRDPLibName">
      <property name="sizePolicy">
       <sizepolicy hsizetype="MinimumExpanding" vsizetype="Fixed">
@@ -80,5 +72,5 @@
    </item>
    <item row="2" column="0">
-    <widget class="QLabel" name="m_pPresentationModeLabel">
+    <widget class="QLabel" name="m_pLabelPresentationMode">
      <property name="text">
       <string>&amp;Dock and Menubar:</string>
@@ -88,10 +80,10 @@
      </property>
      <property name="buddy">
-      <cstring>m_pPresentationModeCheckbox</cstring>
+      <cstring>m_pCheckBoxPresentationMode</cstring>
      </property>
     </widget>
    </item>
    <item row="2" column="1">
-    <widget class="QCheckBox" name="m_pPresentationModeCheckbox">
+    <widget class="QCheckBox" name="m_pCheckBoxPresentationMode">
      <property name="text">
       <string>Auto Show in Fullscreen</string>
@@ -103,5 +95,5 @@
    </item>
    <item row="3" column="0">
-    <widget class="QLabel" name="m_pHostScreenSaverLabel">
+    <widget class="QLabel" name="m_pLabelHostScreenSaver">
      <property name="text">
       <string>&amp;Host Screen Saver:</string>
@@ -111,10 +103,10 @@
      </property>
      <property name="buddy">
-      <cstring>m_pHostScreenSaverCheckbox</cstring>
+      <cstring>m_pCheckBoxHostScreenSaver</cstring>
      </property>
     </widget>
    </item>
    <item row="3" column="1">
-    <widget class="QCheckBox" name="m_pHostScreenSaverCheckbox">
+    <widget class="QCheckBox" name="m_pCheckBoxHostScreenSaver">
      <property name="whatsThis">
       <string>When checked, the host screen saver will be disabled whenever a virtual machine is running.</string>
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsUpdate.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsUpdate.cpp	(revision 47133)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsUpdate.cpp	(revision 47134)
@@ -22,5 +22,4 @@
 #include "VBoxGlobal.h"
 
-/* Update page constructor: */
 UIGlobalSettingsUpdate::UIGlobalSettingsUpdate()
     : m_pLastChosenRadio(0)